### R code from vignette source 'BoolNet_package_vignette.Snw'

###################################################
### code chunk number 1: BoolNet_package_vignette.Snw:65-66 (eval = FALSE)
###################################################
## install.packages("BoolNet")


###################################################
### code chunk number 2: BoolNet_package_vignette.Snw:70-71
###################################################
library(BoolNet)


###################################################
### code chunk number 3: BoolNet_package_vignette.Snw:148-149 (eval = FALSE)
###################################################
## cellcycle <- loadNetwork("cellcycle.txt")


###################################################
### code chunk number 4: BoolNet_package_vignette.Snw:153-154
###################################################
data(cellcycle)


###################################################
### code chunk number 5: BoolNet_package_vignette.Snw:167-168
###################################################
data(yeastTimeSeries)


###################################################
### code chunk number 6: BoolNet_package_vignette.Snw:173-174
###################################################
binSeries <- binarizeTimeSeries(yeastTimeSeries)


###################################################
### code chunk number 7: BoolNet_package_vignette.Snw:179-181
###################################################
net <- reconstructNetwork(binSeries$binarizedMeasurements, 
method="bestfit", maxK=4)


###################################################
### code chunk number 8: BoolNet_package_vignette.Snw:187-188
###################################################
net


###################################################
### code chunk number 9: BoolNet_package_vignette.Snw:193-194
###################################################
plotNetworkWiring(net)


###################################################
### code chunk number 10: BoolNet_package_vignette.Snw:211-212
###################################################
singleNet <- chooseNetwork(net, c(1,2,3,2))


###################################################
### code chunk number 11: BoolNet_package_vignette.Snw:215-216
###################################################
singleNet


###################################################
### code chunk number 12: BoolNet_package_vignette.Snw:220-224 (eval = FALSE)
###################################################
## series <- generateTimeSeries(cellcycle, 
##                              numSeries=100, 
##                              numMeasurements=10, 
##                              noiseLevel=0.1)


###################################################
### code chunk number 13: BoolNet_package_vignette.Snw:229-232 (eval = FALSE)
###################################################
## binSeries <- binarizeTimeSeries(series, method="kmeans")
## net <- reconstructNetwork(binSeries$binarizedMeasurements, method="bestfit")
## net


###################################################
### code chunk number 14: BoolNet_package_vignette.Snw:286-287
###################################################
net <- generateRandomNKNetwork(n=10, k=3)


###################################################
### code chunk number 15: BoolNet_package_vignette.Snw:290-291
###################################################
net <- generateRandomNKNetwork(n=10, k=c(1,2,3,1,3,2,3,2,1,1))


###################################################
### code chunk number 16: BoolNet_package_vignette.Snw:296-297
###################################################
net <- generateRandomNKNetwork(n=20, k=20, topology="scale_free")


###################################################
### code chunk number 17: BoolNet_package_vignette.Snw:301-302
###################################################
net <- generateRandomNKNetwork(n=10, k=3, linkage="lattice")


###################################################
### code chunk number 18: BoolNet_package_vignette.Snw:307-309
###################################################
net <- generateRandomNKNetwork(n=10, k=3, 
functionGeneration="biased", zeroBias=0.75)


###################################################
### code chunk number 19: BoolNet_package_vignette.Snw:316-334
###################################################
isCanalyzing <- function(input, func)
{
  for (i in 1:ncol(input))
  # check each input gene
  {
    inputGene <- input[,i]
    for (v in c(0,1))
    # test for inputs 0 and 1 whether all output
    # values are the same
    {  
      if (length(unique(func[inputGene == v])) == 1)
      # => this gene can determine the output on its own
        return(TRUE)
    }
  }
  # the function is not canalyzing
  return(FALSE)
}


###################################################
### code chunk number 20: BoolNet_package_vignette.Snw:342-344
###################################################
net <- generateRandomNKNetwork(n=10, k=3, 
validationFunction="isCanalyzing", failureIterations=1000)


###################################################
### code chunk number 21: BoolNet_package_vignette.Snw:355-357
###################################################
data(cellcycle)
knockedOut <- fixGenes(cellcycle, "CycD", 0)


###################################################
### code chunk number 22: BoolNet_package_vignette.Snw:360-361
###################################################
knockedOut <- fixGenes(cellcycle, 1, 0)


###################################################
### code chunk number 23: BoolNet_package_vignette.Snw:364-365
###################################################
overExpressed <- fixGenes(cellcycle, "CycD", 1)


###################################################
### code chunk number 24: BoolNet_package_vignette.Snw:368-369
###################################################
originalNet <- fixGenes(knockedOut, "CycD", -1)


###################################################
### code chunk number 25: BoolNet_package_vignette.Snw:374-375
###################################################
newNet <- fixGenes(cellcycle, c("CycD","CycE"), c(0,1))


###################################################
### code chunk number 26: BoolNet_package_vignette.Snw:387-389
###################################################
data(cellcycle)
stateTransition(cellcycle, rep(1,10))


###################################################
### code chunk number 27: BoolNet_package_vignette.Snw:393-395
###################################################
path <- getPathToAttractor(cellcycle, rep(0,10))
path


###################################################
### code chunk number 28: BoolNet_package_vignette.Snw:400-401 (eval = FALSE)
###################################################
## plotSequence(sequence=path)


###################################################
### code chunk number 29: BoolNet_package_vignette.Snw:414-415 (eval = FALSE)
###################################################
## sequenceToLaTeX(sequence=path, file="sequence.tex")


###################################################
### code chunk number 30: BoolNet_package_vignette.Snw:420-422
###################################################
startState <- generateState(cellcycle, specs=c("CycD"=1,"CycA"=1))
stateTransition(cellcycle,startState)


###################################################
### code chunk number 31: BoolNet_package_vignette.Snw:427-428
###################################################
set.seed(54321)


###################################################
### code chunk number 32: BoolNet_package_vignette.Snw:430-431
###################################################
stateTransition(cellcycle, rep(1,10), type="asynchronous")


###################################################
### code chunk number 33: BoolNet_package_vignette.Snw:437-438
###################################################
set.seed(4321)


###################################################
### code chunk number 34: BoolNet_package_vignette.Snw:440-442
###################################################
stateTransition(cellcycle, rep(1,10), type="asynchronous", 
geneProbabilities=c(0.05,0.05,0.2,0.3,0.05,0.05,0.05,0.05,0.1,0.1))


###################################################
### code chunk number 35: BoolNet_package_vignette.Snw:449-451
###################################################
stateTransition(cellcycle, rep(1,10), type="asynchronous", 
chosenGene="CycE")


###################################################
### code chunk number 36: BoolNet_package_vignette.Snw:456-457
###################################################
set.seed(432)


###################################################
### code chunk number 37: BoolNet_package_vignette.Snw:459-461
###################################################
data(examplePBN)
stateTransition(examplePBN, c(0,1,1), type="probabilistic")


###################################################
### code chunk number 38: BoolNet_package_vignette.Snw:464-466
###################################################
stateTransition(examplePBN, c(0,1,1), type="probabilistic", 
chosenFunctions=c(2,1,2))


###################################################
### code chunk number 39: BoolNet_package_vignette.Snw:484-485
###################################################
attr <- getAttractors(cellcycle)


###################################################
### code chunk number 40: BoolNet_package_vignette.Snw:487-490 (eval = FALSE)
###################################################
## data(cellcycle)
## attr <- getAttractors(cellcycle)
## attr


###################################################
### code chunk number 41: BoolNet_package_vignette.Snw:535-536 (eval = FALSE)
###################################################
## print(attr, activeOnly=TRUE)


###################################################
### code chunk number 42: BoolNet_package_vignette.Snw:558-559
###################################################
getAttractorSequence(attr, 2)


###################################################
### code chunk number 43: BoolNet_package_vignette.Snw:566-568 (eval = FALSE)
###################################################
## tt <- getTransitionTable(attr)
## tt


###################################################
### code chunk number 44: BoolNet_package_vignette.Snw:582-583 (eval = FALSE)
###################################################
## getBasinOfAttraction(attr, 1)


###################################################
### code chunk number 45: BoolNet_package_vignette.Snw:588-589 (eval = FALSE)
###################################################
## getStateSummary(attr, c(1,1,1,1,1,1,1,1,1,1))


###################################################
### code chunk number 46: BoolNet_package_vignette.Snw:601-602
###################################################
plotStateGraph(attr)


###################################################
### code chunk number 47: BoolNet_package_vignette.Snw:615-616
###################################################
plotStateGraph(attr, piecewise=TRUE)


###################################################
### code chunk number 48: BoolNet_package_vignette.Snw:630-631 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, method="random", startStates=100)


###################################################
### code chunk number 49: BoolNet_package_vignette.Snw:635-637 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, method="chosen", 
## startStates=list(rep(0,10),rep(1,10)))


###################################################
### code chunk number 50: BoolNet_package_vignette.Snw:646-647 (eval = FALSE)
###################################################
## plotAttractors(attr, subset=2)


###################################################
### code chunk number 51: BoolNet_package_vignette.Snw:650-651 (eval = FALSE)
###################################################
## attractorsToLaTeX(attr, subset=2, file="attractors.tex")


###################################################
### code chunk number 52: BoolNet_package_vignette.Snw:665-667 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, type="asynchronous",
## method="random", startStates=500)


###################################################
### code chunk number 53: BoolNet_package_vignette.Snw:673-674 (eval = FALSE)
###################################################
## attr


###################################################
### code chunk number 54: BoolNet_package_vignette.Snw:701-703 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, type="asynchronous",
## method="random", startStates=500, avoidSelfLoops=FALSE)


###################################################
### code chunk number 55: BoolNet_package_vignette.Snw:710-711 (eval = FALSE)
###################################################
## plotAttractors(attr, subset=2, mode="graph", drawLabels=FALSE)


###################################################
### code chunk number 56: BoolNet_package_vignette.Snw:729-732
###################################################
data(examplePBN)
sim <- markovSimulation(examplePBN)
sim


###################################################
### code chunk number 57: BoolNet_package_vignette.Snw:738-739
###################################################
plotPBNTransitions(sim)


###################################################
### code chunk number 58: BoolNet_package_vignette.Snw:752-756
###################################################
data(cellcycle)
sim <- markovSimulation(cellcycle, numIterations=1024, 
returnTable=FALSE)
sim


###################################################
### code chunk number 59: BoolNet_package_vignette.Snw:765-768
###################################################
sim <- markovSimulation(cellcycle, numIterations=1024,
returnTable=FALSE, startStates=list(rep(1,10)))
sim


###################################################
### code chunk number 60: BoolNet_package_vignette.Snw:777-780
###################################################
data(cellcycle)
perturbedNet <- perturbNetwork(cellcycle, perturb="functions", 
method="bitflip")


###################################################
### code chunk number 61: BoolNet_package_vignette.Snw:785-787
###################################################
perturbedNet <- perturbNetwork(cellcycle, perturb="functions", 
method="shuffle")


###################################################
### code chunk number 62: BoolNet_package_vignette.Snw:793-795
###################################################
perturbedNet <- perturbNetwork(cellcycle, perturb="states", 
method="bitflip", numStates=10)


###################################################
### code chunk number 63: BoolNet_package_vignette.Snw:827-883 (eval = FALSE)
###################################################
## # Perform a robustness test on a network
## # by counting the numbers of perturbed networks
## # containing the attractors of the original net
## 
## library(BoolNet)
## 
## # load mammalian cell cycle network
## data(cellcycle)
## 
## # get attractors in original network
## attrs <- getAttractors(cellcycle, canonical=TRUE)
## 
## # create 1000 perturbed copies of the network and search for attractors
## perturbationResults <- sapply(1:1000, function(i)
## {
##   # perturb network and identify attractors
##   perturbedNet <- perturbNetwork(cellcycle, perturb="functions", method="bitflip")
##   perturbedAttrs <- getAttractors(perturbedNet, canonical=TRUE)
##   
##   # check whether the attractors in the original network exist in the perturbed network
##   attractorIndices <- sapply(attrs$attractors,function(attractor1)
##         {
##           index <- which(sapply(perturbedAttrs$attractors, function(attractor2)
##             {
##               identical(attractor1, attractor2)
##             }))
##           if (length(index) == 0)
##             NA
##           else
##             index
##         })
##   return(attractorIndices)
## })
## 
## # perturbationResults now contains a matrix
## # with the first 2 columns specifying the indices or the 
## # original attractors in the perturbed network 
## # (or NA if the attractor was not found) and the next 2 
## # columns counting the numbers of states
## # in the basin of attraction (or NA if the attractor was not found)
## 
## # measure the total numbers of occurrences of the original attractors in the perturbed copies
## numOccurrences <- apply(perturbationResults[1:length(attrs$attractors),,drop=FALSE], 1,
##                       function(row)sum(!is.na(row)))
## 
## # print original attractors
## cat("Attractors in original network:\n")
## print(attrs)
## 
## # print information
## cat("Number of occurrences of the original attractors",
## 	"in 1000 perturbed copies of the network:\n")
## for (i in 1:length(attrs$attractors))
## {
##   cat("Attractor ",i,": ",numOccurrences[i],"\n",sep="")
## }


###################################################
### code chunk number 64: BoolNet_package_vignette.Snw:893-897 (eval = FALSE)
###################################################
## data(cellcycle)
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testAttractorRobustness", 
## testFunctionParams = list(copies=100))


###################################################
### code chunk number 65: BoolNet_package_vignette.Snw:911-913 (eval = FALSE)
###################################################
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testIndegree")


###################################################
### code chunk number 66: BoolNet_package_vignette.Snw:927-929 (eval = FALSE)
###################################################
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testIndegree", accumulation="kullback_leibler")


###################################################
### code chunk number 67: BoolNet_package_vignette.Snw:950-962
###################################################
testBasinSizes <- function(network, accumulate=TRUE, params)
{
  attr <- getAttractors(network)
  basinSizes <- sapply(attr$attractors, function(a)
                      { 
                         a$basinSize
                      })
   if (accumulate)
     return(mean(basinSizes))
   else
     return(basinSizes)                  
}


###################################################
### code chunk number 68: BoolNet_package_vignette.Snw:968-971 (eval = FALSE)
###################################################
## testNetworkProperties(cellcycle, numRandomNets=1000,
## testFunction="testBasinSizes",
## xlab="Average size of basins of attraction")


###################################################
### code chunk number 69: BoolNet_package_vignette.Snw:994-995
###################################################
saveNetwork(cellcycle, file="cellcycle.txt")


###################################################
### code chunk number 70: BoolNet_package_vignette.Snw:1000-1002
###################################################
net <- generateRandomNKNetwork(n=10, k=3, readableFunctions=FALSE)
saveNetwork(net, file="randomnet.txt", generateDNF=TRUE)


###################################################
### code chunk number 71: BoolNet_package_vignette.Snw:1017-1020
###################################################
toSBML(cellcycle, file="cellcycle.sbml")
sbml_cellcycle <- loadSBML("cellcycle.sbml")
sbml_cellcycle


###################################################
### code chunk number 72: BoolNet_package_vignette.Snw:1039-1040 (eval = FALSE)
###################################################
## system.file("doc/example.btp", package="BoolNet")


###################################################
### code chunk number 73: BoolNet_package_vignette.Snw:1072-1073
###################################################
net <- loadBioTapestry("example.btp")


###################################################
### code chunk number 74: BoolNet_package_vignette.Snw:1078-1079 (eval = FALSE)
###################################################
## net


###################################################
### code chunk number 75: BoolNet_package_vignette.Snw:1102-1103 (eval = FALSE)
###################################################
## plotNetworkWiring(net)


###################################################
### code chunk number 76: BoolNet_package_vignette.Snw:1125-1128 (eval = FALSE)
###################################################
## data(cellcycle)
## attr <- getAttractors(cellcycle)
## toPajek(attr, file="cellcycle.net")


###################################################
### code chunk number 77: BoolNet_package_vignette.Snw:1132-1133 (eval = FALSE)
###################################################
## toPajek(attr, file="cellcycle.net", includeLabels=TRUE)


